import pyvisa
import AWG_7000

try:
    # Initialize VISA
    rm = pyvisa.ResourceManager()

    # List connected resources
    resources = rm.list_resources()
    print(f"\n\n\nConnected devices: {resources}")

    #Instrument TCP/IP address
    address_listed = resources[1]
    address_not_listed = "TCPIP0::192.168.0.55::inst0::INSTR"

    #If you use NI MAX or similar, you can also use one of the adresses in the list 
    master = rm.open_resource(address_not_listed)

    #Initialize AWG
    AWG = AWG_7000.AWG7000(master)
except Exception as e: print(f"The following exception has occured while connecting with the instrument: {e}")



##################################################################################
#Trigger and General Settings
trigger_source = AWG_7000.TriggerInSource.Timer
trigger_timer_interval = 0.4
trigger_threshold = 1
trigger_impedance = AWG_7000.Impedance.Normal
trigger_timing_mode = AWG_7000.TriggerTiming.Fast
trigger_edge = AWG_7000.Slope.Positive
trigger_delay_adjust = 0
wait_mode = AWG_7000.WaitTriggerState.First_sample
jump_mode = AWG_7000.JumpMode.ASAP

#Sequencer parameters
format = AWG_7000.Format.Amplitude_offset
analog_waveform_names = [["SINE", "SINE"],
                  ["RAMP", "RAMP"],
                  ["SQUARE", "SQUARE"]]
amplitudes = [[1, 1.5],
               [0.75, 0.75],
               [1, 1.2]]
offsets = [[0, 0],
            [0, 0.3],
            [0, 0]]
decreasing_strategies = [[AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation],
                         [AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation],
                         AWG_7000.DecreasingStrategy.Decimation, AWG_7000.DecreasingStrategy.Decimation]
increasing_strategies = [[AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation],
                         [AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation],
                         [AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.IncreasingStrategy.Interpolation]]
sub_lengths = [[16384, 16384],
               [16384, 16384],
               [16384, 16384]]
delays = [[0, 0],
          [0, 0],
          [0, 0]]
output_formats = [[AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform],
                  [AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform],
                  [AWG_7000.OutputFormat.Waveform, AWG_7000.OutputFormat.Waveform]]
entry_lengths = [16384, 16384, 16384]
repetitions = [1, 1, 1]
sequencer_length = len(analog_waveform_names)
wait_event = AWG_7000.JumpEvent.Button
jump_event = AWG_7000.JumpEvent.NONE
jump_to_mode = AWG_7000.Mode.Next
jump_to_entry = 1
pattern_code = 1
pattern_mode = AWG_7000.Mode.Next
pattern_jump_to_entry = 1
go_to_mode = AWG_7000.Mode.Next
go_to_entry = 1

#Digital parameters
digital_channels = AWG_7000.ChannelsNumber.Eight
digital_pod = AWG_7000.Pod.PodA
skew = 0
digital_voltage_level = 3
digital_waveforms = ["COUNTER", "COUNTER", "COUNTER"]
marker_custom_pattern = ["CLOCK", "CLOCK", "CLOCK"]
CML_level = AWG_7000.CMLVoltageLevel.mV590
equalization_factor = 0
##################################################################################



try:
    AWG.Initialize(True, True)

    AWG.SetSequencerLength(sequencer_length, AWG_7000.SetValue.PRESENT)

    AWG.ConfigureGeneralSettings(AWG_7000.OperatingMode.Full_rate, AWG_7000.IncreasingStrategy.Interpolation, AWG_7000.DecreasingStrategy.Decimation, AWG_7000.RunMode.Advanced,
                                 wait_mode, 1, AWG_7000.BurstSelection.NumberCycles, jump_mode)
    
    for channel in AWG.channels:
        AWG.ConfigureChannelSettings(channel, 100, 0, 0, 0, 0, AWG_7000.KeepLastMode.CustomOnStop, AWG_7000.Polarity.Normal, 0, 0,
                                     AWG_7000.ChannelOptimization.High_Linearity, 0, AWG_7000.State.OFF, AWG_7000.KeepLastMode.CustomOnStop, 0)

    #Digital settings
    #for name in digital_waveforms:
    #    if name != "": AWG.ConfigureDigitalChannels(digital_channels, digital_pod, digital_voltage_level, AWG_7000.SetValue.PRESENT, CML_level, equalization_factor, AWG_7000.SetValue.PRESENT, skew, AWG_7000.SetValue.PRESENT)
    #    AWG.SetDigitalsState(AWG_7000.State.ON)

    #Program all wanted sequencer entries
    for i in range(sequencer_length):
        entry = AWG_7000.AdvancedSequencerEntry(entry_number=i+1, analog_waveform_names=analog_waveform_names[i], amplitudes=amplitudes[i], offsets=offsets[i],
                                        decreasing_strategies=decreasing_strategies[i], increasing_strategies=increasing_strategies[i], sub_lengths=sub_lengths[i],
                                        delays=delays[i], digital_waveform_name=digital_waveforms[i], custom_pattern=marker_custom_pattern[i], length=entry_lengths[i],
                                        repetitions=repetitions[i], output_formats=output_formats[i], wait_event=wait_event, jump_event=jump_event, jump_to_mode=jump_to_mode,
                                        jump_to_entry_item=jump_to_entry, pattern_code=pattern_code, pattern_mode=pattern_mode, pattern_jump_to_entry=pattern_jump_to_entry,
                                        go_to_mode=go_to_mode, go_to_entry_item=go_to_entry)
        AWG.ConfigureSequencerElement(entry)

    AWG.ConfigureTriggerIn(trigger_source, 0.01, AWG_7000.SetValue.PRESENT, trigger_threshold, trigger_edge, trigger_impedance, trigger_timing_mode, trigger_delay_adjust)

    for channel in AWG.channels: AWG.SetOutputState(channel, AWG_7000.State.ON)




    #HMI
    while(1):
        command = input(f"Command list:   c -> stop the AWG and close;\n\t\ts -> start or stop the AWG;\n\t\tp -> send pattern code {pattern_code};\n\t\tt -> send trigger\nDial command here: ")
        if command == "c":
            AWG.AWGStop()
            AWG.Close()
            AWG_on = False
            break
        elif command == "s":
            if AWG_on:
                AWG.AWGStop()
                AWG_on = False
            else:
                AWG.AWGStart()
                AWG_on = True
        elif command == "p": AWG.SendPatternCode(pattern_code)
        elif command == "t": AWG.SendTrigger()
        else: print("Command not recognized\n")
    AWG.Close()
except Exception as e: print(f"The following exception has occured: {e}")